{{Drive.spin}}

CON   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  'wheel servo directions
  L_CW = 650    'spin clockwise
  L_STOP = 1485 'stop
  L_CCW = 2350  'spin counter-clockwise

  R_CW = 650    'spin clockwise
  R_STOP = 1485 'stop
  R_CCW = 2350  'spin counter-clockwise  

  Left_Wheel = 12  'sig pin for left wheel servo
  Right_Wheel = 10  'sig pin for right wheel servo
  
  High = 1
  Low  = 0

  'bot directions
  BACK = -3
  STOP = 0
  FORWARD = 1
  LTURN = 2
  RTURN = -2
  SPIN = 180

  ACK = 1       'acknowledge
var
 long Drive_Stack[350]
 long Time
 
PUB StartDRIVE(addrDIRECTION,addrSTATUS)
  cognew(TurnWheels(addrDIRECTION,addrSTATUS), @Drive_Stack)         ' start TurnWheels in another cog, pass in addr of global vars

Pub TurnWheels(addrDIRECTION, addrSTATUS)|ldirection

  dira[Left_Wheel]~~             ' set sig pin for left wheel servo to output
  dira[Right_Wheel]~~            ' set sig pin for right wheel servo to output 

  repeat
    ldirection := LONG[addrDIRECTION]  'copy global to local
    if ldirection == FORWARD
      ' drive forward 
      Drive_Servo(Left_Wheel, L_CCW, Right_Wheel, R_CW)
      
      LONG[addrSTATUS] := FORWARD      ' acknowledge command
    elseif ldirection == BACK
      ' drive backward
      Drive_Servo(Left_Wheel, L_CW, Right_Wheel, R_CCW)
      LONG[addrSTATUS] := BACK      ' acknowledge command

      Drive_Servo(Left_Wheel, L_STOP, Right_Wheel, R_STOP)
      LONG[addrSTATUS] := STOP      ' acknowledge command
             
    elseif ldirection == STOP
    ' stop
      Drive_Servo(Left_Wheel, L_STOP, Right_Wheel, R_STOP)
      
      LONG[addrSTATUS] := STOP      ' acknowledge command        
    elseif ldirection == SPIN
    ' 180-degree spin
      Drive_Servo(Left_Wheel, L_CW, Right_Wheel, R_CW)
      
      LONG[addrSTATUS] := SPIN      ' acknowledge command        
    elseif ldirection == LTURN
      ' left turn
      Drive_Servo(Left_Wheel, L_STOP, Right_Wheel, R_CW)
      
      LONG[addrSTATUS] := LTURN      ' acknowledge command        
    elseif ldirection == RTURN
      ' right turn
      Drive_Servo(Left_Wheel, L_CCW, Right_Wheel, R_STOP)
      
      LONG[addrSTATUS] := RTURN      ' acknowledge command        

PUB Drive_Servo(Pin1, Dir1, Pin2, Dir2)
  repeat 25
    Pulsout(Pin1, Dir1, High)
    Pulsout(Pin2, Dir2, High)
    waitcnt(1_600_000 + cnt)

Pub Pulsout(Pin, Duration,  Polarity)
  Dira[Pin] := 1   
  Outa[Pin] := !Polarity  
  Time := Duration * 80
  !Outa[Pin]   
  waitcnt(Time + cnt)
  !Outa[Pin]   