{{PINGscan.spin}}
CON   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  Ping_Turn = 8  'sig pin for PING servo
  Ping_Pin  = 9  'sig pin for PING module

  High = 1
  Low  = 0

  'PING servo directions
  RIGHT = 500 'make standard servo turn cw and stop
  CENTER = 1400 'center servo
  LEFT = 2200 'make standard servo turn ccw and stop

  NUM_SAMPL = 1                 'number of PING samples to read & average
  SAMPL_DELAY = 500               'time delay between taking PING samples, larger number results in smaller delay
  TURN_DELAY = 1000               'time delay between moving between servo directions, larger number results in smaller delay  

OBJ
  nPing: "Ping"
  
var
 long Stack[400]
  
PUB StartPING(addrLRANGE,addrCRANGE,addrRRANGE)
  cognew(GetDist(addrLRANGE,addrCRANGE,addrRRANGE), @Stack)         ' start GetDist in another cog, pass in addr of global var

Pub GetDist(addrLRANGE,addrCRANGE,addrRRANGE) | iTrial
{{trigger reading of PING sensor}}    
  dira[Ping_Turn]~~             ' set sig pin for PING servo to output
  
   
  repeat
    Drive_Servo(Ping_Turn, LEFT)
    iTrial := 0
    repeat NUM_SAMPL
      iTrial := iTrial + nPing.Millimeters(Ping_Pin)
      waitcnt(clkfreq/SAMPL_DELAY + cnt)     ' wait
      next
    LONG[addrLRANGE] := iTrial'/NUM_SAMPL
    waitcnt(clkfreq/TURN_DELAY + cnt)     ' wait
    
    Drive_Servo(Ping_Turn, CENTER)
    iTrial := 0
    repeat NUM_SAMPL
      iTrial := iTrial + nPing.Millimeters(Ping_Pin)
      waitcnt(clkfreq/SAMPL_DELAY + cnt)     ' wait
      next
    LONG[addrCRANGE] := iTrial'/NUM_SAMPL
    waitcnt(clkfreq/TURN_DELAY + cnt)     ' wait
        
    Drive_Servo(Ping_Turn, RIGHT)
    iTrial := 0
    repeat NUM_SAMPL
      iTrial := iTrial + nPing.Millimeters(Ping_Pin)
      waitcnt(clkfreq/SAMPL_DELAY + cnt)     ' wait
      next
    LONG[addrRRANGE] := iTrial'/NUM_SAMPL
    waitcnt(clkfreq/TURN_DELAY + cnt)     ' wait
    
    Drive_Servo(Ping_Turn, CENTER)
    iTrial := 0
    repeat NUM_SAMPL
      iTrial := iTrial + nPing.Millimeters(Ping_Pin)
      waitcnt(clkfreq/SAMPL_DELAY + cnt)     ' wait
      next
    LONG[addrCRANGE] := iTrial'/NUM_SAMPL
    waitcnt(clkfreq/TURN_DELAY + cnt)     ' wait
    next

PUB Drive_Servo(Pin, Angle)
  repeat 25 'turn standard servo 45 degrees or whatever
    Pulsout(Pin, Angle, High)
    waitcnt(1_600_000 + cnt)

Pub Pulsout(Pin, Duration, Polarity) | Time
  Dira[Pin] := 1
  Outa[Pin] := !Polarity
  Time := Duration * 80
  !Outa[Pin]
  waitcnt(Time + cnt)
  !Outa[Pin]      